
;===================================================================================================
.equ integ	=5
	;   
;===================================================================================================
;    _____________________________________________________________
.macro SM
	lds r16,@0	;@0 -    RAM
	ldi r17,1<<@1	;@1 -     
	or r16,r17	
	sts @0,r16	;  	
.endm
;    __________________________________________________________________
.macro CM
	lds r16,@0
	ldi r17,~(1<<@1)
	and r16,r17
	sts @0,r16
.endm
;  _____________________________________________________________________________
.macro FP
	sbrs r25, 0
	set		;@0 -    SRAM
	mov r3, r1		;@1 -   ()
	lds r2, @0
	bld r3, @1
	mov r4, r2
	bld r4, @1
	ldi r16, 1<<@1
	eor r2, r16
	and r2, r3
	bst r2, @1
	sts @0, r4
	ser r25
.endm
;  _______________________________________________________________________________
.macro FN
	sbrs r25, 0
	set
	mov r3, r1		;@0 -    SRAM
	lds r2, @0		;@1 -   ()
	ldi r16, 1<<@1
	bld r3, @1
	mov r4, r2
	bld r4, @1
	eor r3, r16
	and r2, r3
	bst r2, @1
	sts @0, r4
	ser r25
.endm
;   _________________________________________________________________________________
.macro _CALL
	brtc PC+2
	rcall @0
	clr r25
.endm

/*      (  )
        SREG
     R25. 
 /  0/1   0(0xFF  0x00)

*/
.def SR =r25 ;  (       !!!)
; AND  U (reg),(bit)_________________________
.macro U
	clr r2
	clr r3
	sbrs SR,0
	set
	BLD r2,0	;     R2-bit0
	BST @0,@1	;@0 -     
		;@1 -  (  )
	BLD r3,0	;     R3-bit0
	and r2,r3
	BST r2,0	;   
	ser SR 	;0xFF   
.endm
; AND   I/O  Ui ( ),()_______________________
.macro Ui
	in r16,@0
	sbrs sr,0	;    . 
	set
	bld r2,@1	;     @1 -   
	and r2,r16	;  AND
	bst r2,@1	; 	
 	ser SR 	;0xFF   
.endm
; AND-NOT   UN (reg),(bit)_____________________
.macro UN
	clr r2
	clr r3
	sbrs SR,0
	set
	BLD r2,0
	sbrs @0,@1
	set
	sbrc @0,@1
	clt
	BLD r3,0
	and r2,r3
	BST r2,0
	ser SR
.endm
; AND-NOT   I/O  UNi ( ),(bit)_____________________
.macro UNi
	in r16,@0
	clr r2
	clr r3
	sbrs SR,0
	set
	BLD r2,0
	sbrs r16,@1
	set
	sbrc r16,@1
	clt
	BLD r3,0
	and r2,r3
	BST r2,0
	ser SR
.endm

; OR {O}  O (reg),(bit)_____________________
.macro O
	clr r2
	clr r3
	BLD r2,0
	BST @0,@1
	BLD r3,0
	or r2,r3
	BST r2,0
	ser SR

.endm
; ORi {O}  Oi ( ),(bit)_____________________
.macro Oi
	in r16,@0
	clr r2
	clr r3
	BLD r2,0
	BST r16,@1
	BLD r3,0
	or r2,r3
	BST r2,0
	ser SR

.endm

; ON  {-}  ON (reg),(bit)__________________
.macro ON
	clr r2
	clr r3
	BLD r2,0
	clt
	sbrs @0,@1
	set
	BLD r3,0
	or r2,r3
	BST r2,0
	ser SR	
.endm
; ONi  {-}   I/O  ONi ( ),(bit)__________________
.macro ONi
	in r16,@0
	clr r2
	clr r3
	BLD r2,0
	clt
	sbrs r16,@1
	set
	BLD r3,0
	or r2,r3
	BST r2,0
	ser SR	
.endm

; ={eq}    eq (reg),(bit)_________________
.macro eq
	BLD @0,@1
	clr SR
.endm
; ={eqi}   I/O    eqi ( ),(bit)_________________
.macro eqi
	in r16,@0
	BLD r16,@1
	out @0,r16
	clr SR
.endm

; S {s}   s (reg),(bit)____________________
.macro S
	brtc pc+2
	sbr @0,1<<@1
	clr SR
.endm
; Si {s}  I/O   Si ( ),(bit)____________________
.macro Si
	brtc pc+2
	sbi @0,@1
	clr SR
.endm

; R {r}  r (reg),(bit)_____________________
.macro R
	brtc RL1
	cbr @0,1<<@1
RL1:	clr SR
.endm
; Ri {r}   I/O  Ri ( ),(bit)_____________________
.macro Ri
	brtc RiL1
	cbi @0,@1
RiL1:	clr SR
.endm
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++;   ___________________________________________________________________________
.macro INCsram
	lds r16, @0
	cpi r16,integ
	breq PC+2
	inc r16
	sts @0, r16
.endm
;   ____________________________________________________________________________
.macro DECsram
	lds r16, @0
	cpi r16,0
	breq PC+2
	dec r16
	sts @0, r16
.endm
;  _________________________________________________________________________
;    =1. (    SREG)
.macro Press   ;@0 -   PINx ;@1 -   PIN ;@2 -   
	sbis @0, @1	;  =1   
	rjmp Press0	;   -   
	INCsram @2	
Press0:
	sbic @0, @1	;  =0   
	rjmp Press1	; =1 -   
	DECsram @2
Press1:
	lds r16, @2
	cpi r16,integ	;     
	brcs PC+2	;,  r16  
	set	;  
	cpi r16,1	;     
	brcc PC+2	;,  r16  
	clt	;  
	ser r25	;   .
.endm


